### Type parameters

- #### T

### Hierarchy

- Array

### Indexable

[n: number]: T

## Index

### Properties

- length

### Methods

- concat
- every
- filter
- forEach
- indexOf
- join
- lastIndexOf
- map
- pop
- push
- reduce
- reduceRight
- reverse
- shift
- slice
- some
- sort
- splice
- toLocaleString
- toString
- unshift

## Properties

### length

length: number

- Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1199

Gets or sets the length of the array. This is a number one higher than the highest element defined in an array.

## Methods

### concat

- concat(...items: ConcatArray<T>[]): T[]
- concat(...items: (T | ConcatArray<T>)[]): T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1221

  Combines two or more arrays.

  #### Parameters

  - ##### Rest ...items: ConcatArray<T>[]

    Additional items to add to the end of array1.

  #### Returns T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1226

  Combines two or more arrays.

  #### Parameters

  - ##### Rest ...items: (T | ConcatArray<T>)[]

    Additional items to add to the end of array1.

  #### Returns T[]

### every

- every(callbackfn: function, thisArg?: any): boolean

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1286

  Determines whether all the members of an array satisfy the specified test.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The every method calls the callbackfn function for each element in array1 until the callbackfn returns false, or until the end of the array.

    - - (value: T, index: number, array: T[]): boolean

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns boolean

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### filter

- filter<S>(callbackfn: function, thisArg?: any): S[]
- filter(callbackfn: function, thisArg?: any): T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1310

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Type parameters

  - #### S: T

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): boolean

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns boolean

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns S[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1316

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): any

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns any

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns T[]

### forEach

- forEach(callbackfn: function, thisArg?: any): void

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1298

  Performs the specified action for each element in an array.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): void

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns void

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns void

### indexOf

- indexOf(searchElement: T, fromIndex?: undefined | number): number

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1274

  Returns the index of the first occurrence of a value in an array.

  #### Parameters

  - ##### searchElement: T

    The value to locate in the array.

  - ##### Optional fromIndex: undefined | number

    The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.

  #### Returns number

### join

- join(separator?: undefined | string): string

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1231

  Adds all the elements of an array separated by the specified separator string.

  #### Parameters

  - ##### Optional separator: undefined | string

    A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.

  #### Returns string

### lastIndexOf

- lastIndexOf(searchElement: T, fromIndex?: undefined | number): number

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1280

  Returns the index of the last occurrence of a specified value in an array.

  #### Parameters

  - ##### searchElement: T

    The value to locate in the array.

  - ##### Optional fromIndex: undefined | number

    The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.

  #### Returns number

### map

- map<U>(callbackfn: function, thisArg?: any): U[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1304

  Calls a defined callback function on each element of an array, and returns an array that contains the results.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): U

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns U

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns U[]

### pop

- pop(): T | undefined

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1211

  Removes the last element from an array and returns it.

  #### Returns T | undefined

### push

- push(...items: T[]): number

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1216

  Appends new elements to an array, and returns the new length of the array.

  #### Parameters

  - ##### Rest ...items: T[]

    New elements of the Array.

  #### Returns number

### reduce

- reduce(callbackfn: function): T
- reduce(callbackfn: function, initialValue: T): T
- reduce<U>(callbackfn: function, initialValue: U): U

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1322

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1323

  #### Parameters

  - ##### callbackfn: function

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

  - ##### initialValue: T

  #### Returns T

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1329

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: T, currentIndex: number, array: T[]): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reduceRight

- reduceRight(callbackfn: function): T
- reduceRight(callbackfn: function, initialValue: T): T
- reduceRight<U>(callbackfn: function, initialValue: U): U

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1335

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1336

  #### Parameters

  - ##### callbackfn: function

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

  - ##### initialValue: T

  #### Returns T

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1342

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: T, currentIndex: number, array: T[]): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reverse

- reverse(): T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1235

  Reverses the elements in an Array.

  #### Returns T[]

### shift

- shift(): T | undefined

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1239

  Removes the first element from an array and returns it.

  #### Returns T | undefined

### slice

- slice(start?: undefined | number, end?: undefined | number): T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1245

  Returns a section of an array.

  #### Parameters

  - ##### Optional start: undefined | number

    The beginning of the specified portion of the array.

  - ##### Optional end: undefined | number

    The end of the specified portion of the array.

  #### Returns T[]

### some

- some(callbackfn: function, thisArg?: any): boolean

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1292

  Determines whether the specified callback function returns true for any element of an array.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The some method calls the callbackfn function for each element in array1 until the callbackfn returns true, or until the end of the array.

    - - (value: T, index: number, array: T[]): boolean

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns boolean

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### sort

- sort(compareFn?: undefined | function): this

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1250

  Sorts an array.

  #### Parameters

  - ##### Optional compareFn: undefined | function

    The name of the function used to determine the order of the elements. If omitted, the elements are sorted in ascending, ASCII character order.

  #### Returns this

### splice

- splice(start: number, deleteCount?: undefined | number): T[]
- splice(start: number, deleteCount: number, ...items: T[]): T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1256

  Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.

  #### Parameters

  - ##### start: number

    The zero-based location in the array from which to start removing elements.

  - ##### Optional deleteCount: undefined | number

    The number of elements to remove.

  #### Returns T[]

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1263

  Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.

  #### Parameters

  - ##### start: number

    The zero-based location in the array from which to start removing elements.

  - ##### deleteCount: number

    The number of elements to remove.

  - ##### Rest ...items: T[]

    Elements to insert into the array in place of the deleted elements.

  #### Returns T[]

### toLocaleString

- toLocaleString(): string

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1207

  Returns a string representation of an array. The elements are converted to string using their toLocalString methods.

  #### Returns string

### toString

- toString(): string

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1203

  Returns a string representation of an array.

  #### Returns string

### unshift

- unshift(...items: T[]): number

- - Defined in node_modules/typedoc/node_modules/typescript/lib/lib.es5.d.ts:1268

  Inserts new elements at the start of an array.

  #### Parameters

  - ##### Rest ...items: T[]

    Elements to insert at the start of the Array.

  #### Returns number

Generated using TypeDoc